(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/overlay'), require('@angular/cdk/portal'), require('rxjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('angular-material-image-overlay', ['exports', '@angular/core', '@angular/cdk/overlay', '@angular/cdk/portal', 'rxjs', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["angular-material-image-overlay"] = {}, global.ng.core, global.ng.cdk.overlay, global.ng.cdk.portal, global.rxjs, global.ng.common));
})(this, (function (exports, i0, i1, portal, rxjs, common) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    var IMAGE_OVERLAY_DATA_TOKEN = new i0.InjectionToken('IMAGE_OVERLAY_DATA');
    var AngularMaterialImageOverlayComponent = /** @class */ (function () {
        function AngularMaterialImageOverlayComponent(imageOverlayData) {
            this.imageOverlayData = imageOverlayData;
            this.currentImageIndex = 0;
            this.onKeydown = new rxjs.Subject();
            this.onClose = new rxjs.Subject();
            this.images = imageOverlayData.images;
            this.currentImageIndex = this.obtainCurrentImageIndex(imageOverlayData.currentImage);
            this.currentImage = this.images[this.currentImageIndex];
        }
        AngularMaterialImageOverlayComponent.prototype.obtainCurrentImageIndex = function (dataCurrentImage) {
            if (dataCurrentImage) {
                return this.images.indexOf(dataCurrentImage);
            }
            return 0;
        };
        AngularMaterialImageOverlayComponent.prototype.handleKeydown = function (event) {
            this.onKeydown.next(event.key);
        };
        AngularMaterialImageOverlayComponent.prototype.close = function () {
            this.onClose.next();
        };
        AngularMaterialImageOverlayComponent.prototype.nextImage = function () {
            if (this.currentImageIndex < this.images.length - 1) {
                this.currentImageIndex++;
                this.currentImage = this.images[this.currentImageIndex];
            }
        };
        AngularMaterialImageOverlayComponent.prototype.previousImage = function () {
            if (this.currentImageIndex > 0) {
                this.currentImageIndex--;
                this.currentImage = this.images[this.currentImageIndex];
            }
        };
        return AngularMaterialImageOverlayComponent;
    }());
    AngularMaterialImageOverlayComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.14", ngImport: i0__namespace, type: AngularMaterialImageOverlayComponent, deps: [{ token: IMAGE_OVERLAY_DATA_TOKEN }], target: i0__namespace.ɵɵFactoryTarget.Component });
    AngularMaterialImageOverlayComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.14", type: AngularMaterialImageOverlayComponent, selector: "ng-component", host: { listeners: { "document:keydown": "handleKeydown($event)" } }, ngImport: i0__namespace, template: "<img class=\"angular-material-image-overlay-image\" [src]=\"currentImage\">\n<div class=\"angular-material-image-overlay-close\" (click)=\"close()\">Close</div>", styles: [".angular-material-image-overlay-image{border:3px solid gray;height:auto;max-width:500px;width:100%}.angular-material-image-overlay-close{background-color:#696969;border:1px solid slategray;color:#fff;cursor:pointer;font-family:\"Lucida Sans\",\"Lucida Sans Regular\",\"Lucida Grande\",\"Lucida Sans Unicode\",Geneva,Verdana,sans-serif;font-size:small;font-weight:bold;margin:auto;padding:.5em;text-align:center;width:4em}.angular-material-image-overlay-close:hover{background-color:#708090;border:1px solid slategray;color:#fff;cursor:pointer;font-family:\"Lucida Sans\",\"Lucida Sans Regular\",\"Lucida Grande\",\"Lucida Sans Unicode\",Geneva,Verdana,sans-serif;font-size:small;font-weight:bold;margin:auto;padding:.5em;text-align:center;width:4em}\n"] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.14", ngImport: i0__namespace, type: AngularMaterialImageOverlayComponent, decorators: [{
                type: i0.Component,
                args: [{
                        templateUrl: './angular-material-image-overlay.component.html',
                        styleUrls: ['./angular-material-image-overlay.component.scss']
                    }]
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [IMAGE_OVERLAY_DATA_TOKEN]
                        }] }];
        }, propDecorators: { handleKeydown: [{
                    type: i0.HostListener,
                    args: ['document:keydown', ['$event']]
                }] } });

    var AngularMaterialImageOverlayModule = /** @class */ (function () {
        function AngularMaterialImageOverlayModule() {
        }
        return AngularMaterialImageOverlayModule;
    }());
    AngularMaterialImageOverlayModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.14", ngImport: i0__namespace, type: AngularMaterialImageOverlayModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    AngularMaterialImageOverlayModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.14", ngImport: i0__namespace, type: AngularMaterialImageOverlayModule, declarations: [AngularMaterialImageOverlayComponent], imports: [common.CommonModule,
            i1.OverlayModule], exports: [AngularMaterialImageOverlayComponent] });
    AngularMaterialImageOverlayModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.14", ngImport: i0__namespace, type: AngularMaterialImageOverlayModule, imports: [[
                common.CommonModule,
                i1.OverlayModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.14", ngImport: i0__namespace, type: AngularMaterialImageOverlayModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            AngularMaterialImageOverlayComponent
                        ],
                        imports: [
                            common.CommonModule,
                            i1.OverlayModule
                        ],
                        exports: [
                            AngularMaterialImageOverlayComponent
                        ]
                    }]
            }] });

    var AngularMaterialImageOverlayService = /** @class */ (function () {
        function AngularMaterialImageOverlayService(injector, overlay) {
            this.injector = injector;
            this.overlay = overlay;
        }
        AngularMaterialImageOverlayService.prototype.buildInjector = function (images, currentImage) {
            var imageOverlayData = { images: images, currentImage: currentImage };
            return i0.Injector.create({
                providers: [{ provide: IMAGE_OVERLAY_DATA_TOKEN, useValue: imageOverlayData }],
                parent: this.injector
            });
        };
        AngularMaterialImageOverlayService.prototype.buildOverlayConfig = function () {
            var result = new i1.OverlayConfig();
            result.hasBackdrop = true;
            result.positionStrategy = this.overlay.position().global().centerVertically().centerHorizontally();
            return result;
        };
        AngularMaterialImageOverlayService.prototype.open = function (images, currentImage) {
            var _this = this;
            var imagesInjector = this.buildInjector(images, currentImage);
            var imagePortal = new portal.ComponentPortal(AngularMaterialImageOverlayComponent, null, imagesInjector);
            this.overlayRef = this.overlay.create(this.buildOverlayConfig());
            this.overlayRef.backdropClick().subscribe(function () { return _this.overlayRef.dispose(); });
            this.imageOverlayComponentRef = this.overlayRef.attach(imagePortal);
            this.imageOverlayComponentRef.instance.onKeydown.subscribe(function (keycode) { return _this.onKeydown(keycode); });
            this.imageOverlayComponentRef.instance.onClose.subscribe(function () { return _this.overlayRef.dispose(); });
        };
        AngularMaterialImageOverlayService.prototype.onKeydown = function (keycode) {
            switch (keycode) {
                case ('ArrowRight'):
                case ('ArrowDown'):
                    this.imageOverlayComponentRef.instance.nextImage();
                    break;
                case ('ArrowLeft'):
                case ('ArrowUp'):
                    this.imageOverlayComponentRef.instance.previousImage();
                    break;
                case ('Escape'):
                    this.overlayRef.dispose();
            }
        };
        return AngularMaterialImageOverlayService;
    }());
    AngularMaterialImageOverlayService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.14", ngImport: i0__namespace, type: AngularMaterialImageOverlayService, deps: [{ token: i0__namespace.Injector }, { token: i1__namespace.Overlay }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    AngularMaterialImageOverlayService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.14", ngImport: i0__namespace, type: AngularMaterialImageOverlayService, providedIn: AngularMaterialImageOverlayModule });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.14", ngImport: i0__namespace, type: AngularMaterialImageOverlayService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: AngularMaterialImageOverlayModule
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.Injector }, { type: i1__namespace.Overlay }]; } });

    /*
     * Public API Surface of angular-material-image-overlay
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AngularMaterialImageOverlayComponent = AngularMaterialImageOverlayComponent;
    exports.AngularMaterialImageOverlayModule = AngularMaterialImageOverlayModule;
    exports.AngularMaterialImageOverlayService = AngularMaterialImageOverlayService;
    exports.IMAGE_OVERLAY_DATA_TOKEN = IMAGE_OVERLAY_DATA_TOKEN;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=angular-material-image-overlay.umd.js.map
